#  CMake configure file for alps-accumulators. Defines:
#  alps-accumulators_FOUND        - System has alps-accumulators
#  alps-accumulators_LIBRARIES    - The alps-accumulators libraries (external targets)
#  alps-accumulators_HAS_MPI      - The alps-accumulators is compiled with MPI enabled

# FIXME: is not affected by alps-accumulators_LIBRARY

foreach(dep_ alps-utilities;alps-hdf5)
  find_package(${dep_} PATHS ${CMAKE_CURRENT_LIST_DIR}/../${dep_} NO_DEFAULT_PATH)
endforeach()
unset(dep_)

include(${CMAKE_CURRENT_LIST_DIR}/alps-accumulators.cmake)

set(alps-accumulators_HAS_MPI TRUE)
set(alps-accumulators_LIBRARIES alps::alps-accumulators)

if (NOT ALPSCore_HAS_EIGEN_VERSION)
  set(ALPSCore_HAS_EIGEN_VERSION "3.4.0")
endif()

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(alps-accumulators DEFAULT_MSG alps-accumulators_LIBRARIES)
