#  CMake configure file for alps-mc. Defines:
#  alps-mc_FOUND        - System has alps-mc
#  alps-mc_LIBRARIES    - The alps-mc libraries (external targets)
#  alps-mc_HAS_MPI      - The alps-mc is compiled with MPI enabled

# FIXME: is not affected by alps-mc_LIBRARY

foreach(dep_ alps-utilities;alps-hdf5;alps-params;alps-accumulators)
  find_package(${dep_} PATHS ${CMAKE_CURRENT_LIST_DIR}/../${dep_} NO_DEFAULT_PATH)
endforeach()
unset(dep_)

include(${CMAKE_CURRENT_LIST_DIR}/alps-mc.cmake)

set(alps-mc_HAS_MPI TRUE)
set(alps-mc_LIBRARIES alps::alps-mc)

if (NOT ALPSCore_HAS_EIGEN_VERSION)
  set(ALPSCore_HAS_EIGEN_VERSION "")
endif()

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(alps-mc DEFAULT_MSG alps-mc_LIBRARIES)
